/**
 * Program skeleton for the course "Programming embedded systems"
 */

#include <stdio.h>

/* Scheduler includes. */
#include "FreeRTOS.h"
#include "stm32f10x_conf.h"
#include "stm32f10x_gpio.h"
#include "task.h"
#include "setup.h"

/*-----------------------------------------------------------*/

void myTask(void *params) {
  u8 data;

  for (;;) {
    data = GPIO_ReadInputDataBit(GPIOA, GPIO_Pin_0);

    printf("%d\n", data);

    vTaskDelay(20 / portTICK_RATE_MS);
  }
}

/*
 * Entry point of program execution
 */
int main( void )
{
  GPIO_InitTypeDef GPIO_InitStructure;

  prvSetupHardware();

  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_0 | GPIO_Pin_1;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IPU;
  GPIO_Init( GPIOA, &GPIO_InitStructure );

  xTaskCreate(myTask, "GPIO reader", 100, NULL, 1, NULL);

  vTaskStartScheduler();
  assert(0);
  return 0;                 // not reachable
}
/*-----------------------------------------------------------*/


