/**
 * Program skeleton for the course "Programming embedded systems"
 */

#include <stdio.h>

/* Scheduler includes. */
#include "FreeRTOS.h"
#include "stm32f10x_conf.h"
#include "stm32f10x_gpio.h"
#include "task.h"
#include "setup.h"

/*-----------------------------------------------------------*/

#define DEBOUNCE_PERIOD (20 / portTICK_RATE_MS)

void myTask(void *params) {
  for (;;) {
    GPIO_WriteBit(GPIOA, GPIO_Pin_0, Bit_SET);
    vTaskDelay(20 / portTICK_RATE_MS);
    GPIO_WriteBit(GPIOA, GPIO_Pin_0, Bit_RESET);
    vTaskDelay(20 / portTICK_RATE_MS);
  }
}

/*
 * Entry point of program execution
 */
int main( void )
{
  GPIO_InitTypeDef GPIO_InitStructure;

  prvSetupHardware();

  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_0 | GPIO_Pin_1 | GPIO_Pin_2 | GPIO_Pin_3;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_2MHz;
  GPIO_Init( GPIOA, &GPIO_InitStructure );

  xTaskCreate(myTask, "GPIO writer", 100, NULL, 1, NULL);

  vTaskStartScheduler();
  assert(0);
  return 0;                 // not reachable
}
/*-----------------------------------------------------------*/


