/**
 * Program skeleton for the course "Programming embedded systems"
 */

#include <stdio.h>

/* Scheduler includes. */
#include "FreeRTOS.h"
#include "stm32f10x_conf.h"
#include "task.h"
#include "semphr.h"
#include "setup.h"

/*-----------------------------------------------------------*/

/*
 Note: you need to include the definition

         #define configUSE_MUTEXES           1

 in the FreeRTOSConfig.h file to make this example compile
 */

xSemaphoreHandle mutex;

volatile int sharedData;

void task1(void *params) {
  int i;

  for (;;) {
    for (i = 0; i < 100000; ++i) {
//	  xSemaphoreTake(mutex, portMAX_DELAY);
	  ++sharedData;
//	  xSemaphoreGive(mutex);
    }
    printf("Finished 1: %d\n", sharedData);
    vTaskDelay(portMAX_DELAY);
  }
}

void task2(void *params) {
  int i;

  for (;;) {
    for (i = 0; i < 100000; ++i) {
//	  xSemaphoreTake(mutex, portMAX_DELAY);
	  ++sharedData;
//	  xSemaphoreGive(mutex);
    }
    printf("Finished 2: %d\n", sharedData);
    vTaskDelay(portMAX_DELAY);
  }
}

/*
 * Entry point of program execution
 */
int main( void )
{
  prvSetupHardware();

  mutex = xSemaphoreCreateMutex();

  sharedData = 0;

  xTaskCreate(task1, "task1", 100, NULL, 1, NULL);
  xTaskCreate(task2, "task2", 100, NULL, 1, NULL);

  vTaskStartScheduler();
  assert(0);
  return 0;                 // not reachable
}
/*-----------------------------------------------------------*/


